--
-- JS' Hunter Bar
--
-- US - Blackhand - Alliance (Js)
--
-- www.transcended.us forums for support
--

if select(2, UnitClass("player")) ~= "HUNTER" then return end

-- Show slash command
print(JSHB.locale.greeting1 .. strsub(JSHB.ver,7) .. JSHB.locale.greeting2)

JSHB.mainframe 	= CreateFrame("StatusBar", "JSHB_MainFrame", UIParent)
local mF 	= JSHB.mainframe
local loc	= JSHB.locale
local sp	= JSHB.spellid
local opt

SLASH_JSHB1 	= "/jsb"
SLASH_JSHB2 	= "/jshb"
SLASH_JSHB3 	= "/jsbar"

local classColors		= { RAID_CLASS_COLORS[select(2, UnitClass("player"))].r, RAID_CLASS_COLORS[select(2, UnitClass("player"))].g, RAID_CLASS_COLORS[select(2, UnitClass("player"))].b }
local moveColor			= { 0, .5, 0, 1 } -- Green
local updateInterval		= 0.04
local playerGUID		= nil
local barLocked 		= true
local powerMax 			= 0
local lastUpdate 		= 0
local combatActive 		= false
local isCasting 		= false
local predictionAdjustment	= 0			-- We need to modify the amount to Predict, based on talents, procs, etc.
local terminationBase		= 3 			-- Base per point value for Termination talent
local predictionSpell 		= 9			-- Incoming focus base for prediction
local autoShotStartTime		= 0
local autoShotEndTime		= 0
local JSHBTick			= nil
local tickmin			= nil
local currentPower		= 0
local JSHBTimerFrames  		= { }
local JSHBCCFrames 		= { }
local JSHBDebuffFrames 		= { }
local JSHBMarkFrame 		= nil
local JSHBTranqFrame		= nil
local JSHBCDIconFrame		= nil
local JSBAutoShotBar		= nil
local spellCastID		= 0
local currentTree		= 0
local iconSize			= 0
local time			= 0
local mainSpell			= 0
local barColor			= { 0, 0, 0 }
local tempVars			= { }
local f, i, x, y

-- Variables used by Tukui.
local T, C, L, borderr, borderg, borderb, backdropr, backdropg, backdropb

-- Anchor frames for movement
JSHB.anchorFrame = {}
JSHB.anchorFrame.tranqAlert 	= CreateFrame("Frame", "JSHB_MainFrame_Anchor_tranqAlert", UIParent)
JSHB.anchorFrame.markReminder 	= CreateFrame("Frame", "JSHB_MainFrame_Anchor_markReminder", UIParent)
JSHB.anchorFrame.debuffAlert 	= CreateFrame("Frame", "JSHB_MainFrame_Anchor_debuffAlert", UIParent)
JSHB.anchorFrame.cdIcons 	= CreateFrame("Frame", "JSHB_MainFrame_Anchor_cdIconAlert", UIParent)
JSHB.anchorFrame.ccIcons 	= CreateFrame("Frame", "JSHB_MainFrame_Anchor_ccIcons", UIParent)



local function makeTukui(frame, isIcon)

	local border = CreateFrame("Frame", nil, frame)

	border:SetBackdrop({
	  bgFile = JSHB.tex[JSHB.tex.getTextureIndex("Blank")][2], 
	  edgeFile = JSHB.tex[JSHB.tex.getTextureIndex("Blank")][2], 
	  tile = false, tileSize = 0, edgeSize = 1, 
	  insets = { left = -1, right = -1, top = -1, bottom = -1}
	})

	border:SetPoint("TOPLEFT", -2, 2)
	border:SetPoint("BOTTOMRIGHT", 2, -2)
	border:SetFrameLevel(frame:GetFrameLevel() - 1)

	if IsAddOnLoaded("Tukui") and strsub(GetAddOnMetadata("Tukui", "Version"),1, 2) == "13" then
		borderr, borderg, borderb = unpack(C["media"].bordercolor)
		backdropr, backdropg, backdropb = unpack(C["media"].backdropcolor)

		border:SetBackdropColor(backdropr,backdropg,backdropb,1)
		border:SetBackdropBorderColor(borderr,borderg,borderb,1)

	else
		border:SetBackdropColor(.1,.1,.1,1)
		border:SetBackdropBorderColor(.6,.6,.6,1)
	end

	if not isIcon then frame.Icon:SetTexCoord(0.08,0.92,0.08,0.92) end

	return border
end


local function getChatChan()

	if mF.db.tranqannouncechannel ~= 1 then return mF.db.tranqannouncechannel end

	local zoneType = select(2, IsInInstance())
	if zoneType == "pvp" or zoneType == "arena" then
		return "BATTLEGROUND"
	elseif GetNumRaidMembers() > 0 then
		return "RAID"
	elseif GetNumPartyMembers() > 0 then
		return "PARTY"
	else
		return "SAY"
	end
end


-- Check for Debuff on target unit, cast by player
local function checkForTargetDebuff(spellID)
	time = GetTime()
	tempVars[1], _, _, _, _, tempVars[2], tempVars[3] = UnitAura("target", GetSpellInfo(spellID), nil, "PLAYER|HARMFUL")
	return tempVars[1] and true or false, tempVars[1] and tempVars[2] or 0, (tempVars[1] and (tempVars[3] - time) > 0) and math.max(tempVars[3] - time, 0) or 0
end


-- Check for Buff or Cooldown of ability on player unit, cast by player - getDuration = true for duration, false for CD
local function checkForPlayerBuff(spellID, getDuration)
	if getDuration then
		time = GetTime()
		tempVars[1], _, _, _, _, tempVars[2], tempVars[3] = UnitAura("player", GetSpellInfo(spellID), nil, "PLAYER|HELPFUL")
		return tempVars[1] and true or false, tempVars[1] and tempVars[2] or 0, tempVars[1] and math.max(tempVars[3] - time, 0) or 0
	else
		time = GetTime()
		tempVars[1], tempVars[2] = GetSpellCooldown(spellID)

		-- Need to hack this code a bit, because if we are on GCD it will trigger this to have a duration.
		-- Assuming the duration cannot be less than 1.9, we can override the issues with a simple hack.
		if tempVars[2] > 1.9 then
			return tempVars[2] == 0 and false or true, tempVars[2] == 0 and 0 or tempVars[2], tempVars[2] == 0 and 0 or math.max(tempVars[1] + tempVars[2] - time, 0)
		else
			return false, 0, 0 -- easy!
		end
	end
end


local function getIconOffset(whichPos)
	iconSize = mF.db.iconSize > 0 and (mF.db.iconSize) or (mF:GetHeight())

	if whichPos == JSHB.pos.TOP or whichPos == JSHB.pos.RIGHT then
		return ((mF:GetHeight() / 2) + (mF.db.enabletukuitimers and 4 or 2)) -- +4 or +2 for the border from the bar's inset
	elseif whichPos == JSHB.pos.BOTTOM or whichPos == JSHB.pos.LEFT then
		return (-((mF:GetHeight() / 2) + (mF.db.enabletukuitimers and 4 or 2)))
	elseif whichPos == JSHB.pos.ABOVE then
		return ((mF:GetHeight() / 2) + (iconSize/2) + (mF.db.enabletukuitimers and 5 or 3)) -- +5 or +3 for border from inset + 1 px spacing
	elseif whichPos == JSHB.pos.BELOW then
		return (-((mF:GetHeight() / 2) + (iconSize/2) + (mF.db.enabletukuitimers and 5 or 3)))
	elseif whichPos == JSHB.pos.CENTER then
		return 0
	end
end


local function getTimerXPos(durationLeft, durationMax)
	iconSize = mF.db.iconSize > 0 and (mF.db.iconSize) or (mF:GetHeight())
	return ((((durationLeft / durationMax) * 100) * (((mF:GetWidth() - iconSize) + (mF.db.enabletukuitimers and 0 or 4)) / 100)) - (mF.db.enabletukuitimers and 0 or 2)) -- the +4 and -2 are taking the borders into account
end


local function formatTimeText(val, tenths, autocolor)
	if (val >= 3600) then
		return autocolor and format('|cffccccff%dh|r', math.floor((val+1800) / 3600)) or format('%dh', math.floor((val+1800) / 3600))

	elseif (val >= 60 ) then
		return autocolor and format('|cffffffff%dm|r', math.floor((val+30) / 60)) or format('%dm', math.floor((val+30) / 60))

	elseif (val > 10) then
		return autocolor and format('|cffffff00%d|r', math.floor(val)) or format('%d', math.floor(val))

	elseif (val > 0) then
		if tenths then
			return autocolor and format('|cffff0000%.1f|r', val) or format('%.1f', val)
		else
			return autocolor and format('|cffff0000%d|r', math.floor(val)) or format('%d', math.floor(val))
		end
	end
end


--Code from stripped omnicc in TukUI, which is in respect (originally) from OmniCC - Thanks to both authors for permission
local function jSBTimer_Stop(self)
	self.enabled = nil
	self:Hide()
end


--Code from stripped omnicc in TukUI, which is in respect (originally) from OmniCC - Thanks to both authors for permission
local function jSBTimer_ForceUpdate(self)
	self.nextUpdate = 0
	self:Show()
end


--Code from stripped omnicc in TukUI, which is in respect (originally) from OmniCC - Thanks to both authors for permission
local function jSBTimer_OnSizeChanged(self, width, height)
	local fontScale = floor(width + 0.5) / 30 -- 30 is the default iconsize for cctimers.
	if fontScale == self.fontScale then
		return
	end

	self.fontScale = fontScale
	if fontScale < .4 then
		self:Hide()
	else
		self.text:SetFont(JSHB.fnts[JSHB.fnts.getFontIndex(mF.db.timerfont)][2], fontScale * 18, 'OUTLINE') -- 16px font size based on icon size of 30
		self.text:SetShadowColor(0, 0, 0, 0.5)
		self.text:SetShadowOffset(2, -2)
		if self.enabled then
			jSBTimer_ForceUpdate(self)
		end
	end
end


--Code from stripped omnicc in TukUI, which is in respect (originally) from OmniCC - Thanks to both authors for permission
local function jSBTimer_OnUpdate(self, elapsed)
	if self.nextUpdate > 0 then
		self.nextUpdate = self.nextUpdate - elapsed
	else
		local remain = self.duration - (GetTime() - self.start)
		if floor(remain + 0.1) > 0 then
			self.text:SetText(formatTimeText(remain, false, true))
			self.nextUpdate = 0.1
		else
			jSBTimer_Stop(self)
		end
	end
end


local function jSBTimer_Create(self)
	local scaler = CreateFrame('Frame', nil, self)
	scaler:SetAllPoints(self)

	local timer = CreateFrame('Frame', nil, scaler)
	timer:Hide()
	timer:SetAllPoints(scaler)
	timer:SetScript('OnUpdate', jSBTimer_OnUpdate)

	local text = timer:CreateFontString(nil, 'OVERLAY')
	text:SetPoint('CENTER', (floor(self:GetWidth() + 0.5) / 30) * 2, 0) -- 2px offset based on 18px font and 30px standard icon width
	text:SetJustifyH("CENTER")
	text:SetJustifyV("CENTER")
	timer.text = text

	jSBTimer_OnSizeChanged(timer, scaler:GetSize())
	scaler:SetScript('OnSizeChanged', function(self, ...) jSBTimer_OnSizeChanged(timer, ...) end)

	self.timer = timer
	return timer
end


local function stopCCTimer(spellID, targetGUID)
	local i
	for i=1,3 do
		if (JSHBCCFrames[i].active == true) and (JSHBCCFrames[i].spellID == spellID) and (JSHBCCFrames[i].guid == targetGUID) then

			JSHBCCFrames[i]:SetAlpha(0)
			JSHBCCFrames[i].guid = 0
			JSHBCCFrames[i].spellID = 0
			JSHBCCFrames[i].active = false
			JSHBCCFrames[i].killtime = 0

			if JSHBCCFrames[i].timer then
				JSHBCCFrames[i].timer.enabled = nil
				JSHBCCFrames[i].timer:Hide()
			end

			break -- Found the right one, stop the loop
		end
	end
end


local function repositionCCTimers()
	local x
	local j = 1
	for i=1,3 do
		if JSHBCCFrames[i].active == true then
			if (JSHBCCFrames[i].killtime < GetTime()) then
				stopCCTimer(JSHBCCFrames[i].spellID, JSHBCCFrames[i].guid)
			else
				if mF.db.ccAnchorPointOffsetX <= 0 then -- Expand Left
					x = (-(((j-1)*(mF.db.cCIconSize + (mF.db.enabletukui and 6 or 2))) )) + mF.db.ccAnchorPointOffsetX
				else -- Expand Right
					x = (((j-1)*(mF.db.cCIconSize + (mF.db.enabletukui and 6 or 2))) ) + mF.db.ccAnchorPointOffsetX
				end

				JSHBCCFrames[i]:SetPoint(mF.db.ccAnchorPoint, 'UIParent', mF.db.ccAnchorPointRelative, x, mF.db.ccAnchorPointOffsetY)

				j = j + 1
			end
		end
	end
end


local function addCCTimer(spellID, targetGUID, expireTime)
	local i
	currentTime = GetTime()
	for i=2,4 do -- Position Wyvern first, as it's only a 30s duration.
		if (JSHBCCFrames[i].active == false) or (spellID == sp.wyvernsting) then

			if (spellID == sp.wyvernsting) then i = 1 end

			JSHBCCFrames[i].Icon:SetTexture(select(3, GetSpellInfo(spellID)))
			JSHBCCFrames[i].Icon:SetAllPoints(JSHBCCFrames[i])

			if barLocked then
				JSHBCCFrames[i]:Show()
				JSHBCCFrames[i]:SetAlpha(1) 
			end

			JSHBCCFrames[i].killtime = GetTime() + expireTime + .2
			JSHBCCFrames[i].guid = targetGUID -- Need to know the target id associated with this frame.
			JSHBCCFrames[i].spellID = spellID
			JSHBCCFrames[i].active = true

			local timer = JSHBCCFrames[i].timer or jSBTimer_Create(JSHBCCFrames[i])
			timer.start = GetTime()
			timer.duration = expireTime
			timer.enabled = true
			timer.nextUpdate = 0
			timer:Show()

			break
		end
	end
end


local function refreshCCTimer(spellID, targetGUID, expireTime)

	currentTime = GetTime()	
	for i=1,4 do
		if (JSHBCCFrames[i].active == true) and (JSHBCCFrames[i].spellID == spellID) and (JSHBCCFrames[i].guid == targetGUID) then

			JSHBCCFrames[i].killtime = currentTime + expireTime + .2

			local timer = JSHBCCFrames[i].timer or jSBTimer_Create(JSHBCCFrames[i])
			timer.start = GetTime()
			timer.duration = expireTime
			timer.enabled = true
			timer.nextUpdate = 0
			timer:Show()

			break
		end
	end
end


local function setCCTimers()
	local i, x

	for i=1,4 do
		if JSHBCCFrames[i] ~= nil then
			JSHBCCFrames[i]:SetAlpha(0)
			JSHBCCFrames[i].active = false

			if JSHBCCFrames[i].timer then
				JSHBCCFrames[i].timer.enabled = nil
				JSHBCCFrames[i].timer:Hide()
			end

			JSHBCCFrames[i] = nil
		end
	end

	if not mF.db.enablecctimers then return end

	for i=1,4 do -- Allocating 4 frames, more than enough, low overhead
		JSHBCCFrames[i] = CreateFrame("Frame", nil, mF)
		JSHBCCFrames[i]:SetWidth(mF.db.cCIconSize)
		JSHBCCFrames[i]:SetHeight(mF.db.cCIconSize)

		if mF.db.ccAnchorPointOffsetX <= 0 then -- Expand Left
			x = (-(i*(mF.db.cCIconSize+2))) + mF.db.ccAnchorPointOffsetX
		else -- Expand Right
			x = (i*(mF.db.cCIconSize+2)) + mF.db.ccAnchorPointOffsetX
		end

		JSHBCCFrames[i]:SetPoint(mF.db.ccAnchorPoint, 'UIParent', mF.db.ccAnchorPointRelative, x, mF.db.ccAnchorPointOffsetY)

		JSHBCCFrames[i].Icon = JSHBCCFrames[i]:CreateTexture(nil, "BACKGROUND")

		-- Makes the frames look a bit more like tukui, plan to do this better later.
		if mF.db.enabletukui then
			JSHBCCFrames[i].border = makeTukui(JSHBCCFrames[i])
		end

		JSHBCCFrames[i]:Hide()
		JSHBCCFrames[i]:SetAlpha(0)

		JSHBCCFrames[i].guid = 0
		JSHBCCFrames[i].spellID = 0
		JSHBCCFrames[i].active = false

	end
end


local function stopDebuffAlert(spellID)
	local i
	for i=1,6 do
		if (JSHBDebuffFrames[i].active == true) and (JSHBDebuffFrames[i].spellID == spellID) then

			JSHBDebuffFrames[i].Stacks:Hide()
			JSHBDebuffFrames[i]:Hide()
			JSHBDebuffFrames[i].spellID = 0
			JSHBDebuffFrames[i].active = false
			JSHBDebuffFrames[i].killtime = 0

			if JSHBDebuffFrames[i].timer then
				JSHBDebuffFrames[i].timer.enabled = nil
				JSHBDebuffFrames[i].timer:Hide()
			end
			break -- Found the right one, stop the loop
		end
	end
end


local function repositionDebuffAlert()
	local x
	local j = 1
	for i=1,6 do
		if JSHBDebuffFrames[i].active == true then
			if (JSHBDebuffFrames[i].killtime < GetTime()) then
				stopDebuffAlert(JSHBDebuffFrames[i].spellID)
			else
				if mF.db.debuffAnchorPointOffsetX <= 0 then -- Expand Left
					x = (-(((j-1)*(mF.db.debufficonsize + (mF.db.enabletukui and 8 or 4))) )) + mF.db.debuffAnchorPointOffsetX
				else -- Expand Right
					x = (((j-1)*(mF.db.debufficonsize + (mF.db.enabletukui and 8 or 4))) ) + mF.db.debuffAnchorPointOffsetX
				end

				JSHBDebuffFrames[i]:SetPoint(mF.db.debuffAnchorPoint, 'UIParent', mF.db.debuffAnchorPointRelative, x, mF.db.debuffAnchorPointOffsetY)
				j = j + 1
			end
		end
	end
end


local function addDebuffAlert(spellID, expireTime, stacks)
	local i
	currentTime = GetTime()
	for i=1,6 do
		if (JSHBDebuffFrames[i].active == false) then

			JSHBDebuffFrames[i].Icon:SetTexture(select(3, GetSpellInfo(spellID)))
			JSHBDebuffFrames[i].Icon:SetAllPoints(JSHBDebuffFrames[i])

			if stacks and (stacks > 0) then 
				JSHBDebuffFrames[i].Stacks:SetText(stacks)
				JSHBDebuffFrames[i].Stacks:Show()
			else
				JSHBDebuffFrames[i].Stacks:Hide()
			end

			if barLocked then
				JSHBDebuffFrames[i]:Show()
			end

			JSHBDebuffFrames[i].killtime = GetTime() + expireTime + .2
			JSHBDebuffFrames[i].spellID = spellID
			JSHBDebuffFrames[i].active = true

			local timer = JSHBDebuffFrames[i].timer or jSBTimer_Create(JSHBDebuffFrames[i])
			timer.start = GetTime()
			timer.duration = expireTime
			timer.enabled = true
			timer.nextUpdate = 0
			timer:Show()

			break
		end
	end
end


local function refreshDebuffAlert(spellID, expireTime, stacks)

	currentTime = GetTime()	
	for i=1,6 do
		if (JSHBDebuffFrames[i].active == true) and (JSHBDebuffFrames[i].spellID == spellID) then

			JSHBDebuffFrames[i].killtime = currentTime + expireTime + .2

			if stacks and (stacks > 0) then 
				JSHBDebuffFrames[i].Stacks:SetText(stacks)
				JSHBDebuffFrames[i].Stacks:Show()
			else
				JSHBDebuffFrames[i].Stacks:Hide()
			end

			local timer = JSHBDebuffFrames[i].timer or jSBTimer_Create(JSHBDebuffFrames[i])
			timer.start = GetTime()
			timer.duration = expireTime
			timer.enabled = true
			timer.nextUpdate = 0
			timer:Show()

			break
		end
	end
end


local function setDebuffAlert()
	local i, x

	for i=1,6 do
		if JSHBDebuffFrames[i] ~= nil then
			JSHBDebuffFrames[i]:Hide()
			JSHBDebuffFrames[i].active = false

			if JSHBDebuffFrames[i].timer then
				JSHBDebuffFrames[i].timer.enabled = nil
				JSHBDebuffFrames[i].timer:Hide()
			end

			JSHBDebuffFrames[i] = nil
		end
	end

	if not mF.db.enabledebuffalert then return end

	for i=1,6 do -- Allocating 6 frames, more than enough, low overhead
		JSHBDebuffFrames[i] = CreateFrame("Frame", nil, mF)
		JSHBDebuffFrames[i]:SetWidth(mF.db.debufficonsize)
		JSHBDebuffFrames[i]:SetHeight(mF.db.debufficonsize)

		if mF.db.debuffAnchorPointOffsetX <= 0 then -- Expand Left
			x = (-(i*(mF.db.debufficonsize+4))) + mF.db.debuffAnchorPointOffsetX
		else -- Expand Right
			x = (i*(mF.db.debufficonsize+4)) + mF.db.debuffAnchorPointOffsetX
		end

		JSHBDebuffFrames[i]:SetPoint(mF.db.debuffAnchorPoint, 'UIParent', mF.db.debuffAnchorPointRelative, x, mF.db.debuffAnchorPointOffsetY)

		JSHBDebuffFrames[i].Icon = JSHBDebuffFrames[i]:CreateTexture(nil, "BACKGROUND")

		-- Makes the frames look a bit more like tukui, plan to do this better later.
		if mF.db.enabletukui then
			JSHBDebuffFrames[i].border = makeTukui(JSHBDebuffFrames[i])
		end

		JSHBDebuffFrames[i]:Hide()
		JSHBDebuffFrames[i].spellID = 0
		JSHBDebuffFrames[i].active = false
		JSHBDebuffFrames[i]:SetScript("OnEnter", function(self)
			if self.spellID == 0 then return end
			local index
			for index=1,40 do
				if (select(11, UnitDebuff("player", index)) == self.spellID) then
					GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
					GameTooltip:SetUnitDebuff("player", index)
					GameTooltip:Show()
					break
				end
			end			
		end)
		JSHBDebuffFrames[i]:SetScript("OnLeave", function(self) if self.spellID == 0 then return end; GameTooltip:Hide() end)

		JSHBDebuffFrames[i].Stacks = JSHBDebuffFrames[i]:CreateFontString(nil, "OVERLAY", JSHBDebuffFrames[i])
		JSHBDebuffFrames[i].Stacks:SetJustifyH("RIGHT")
		JSHBDebuffFrames[i].Stacks:SetJustifyV("BOTTOM")
		JSHBDebuffFrames[i].Stacks:SetPoint("BOTTOMRIGHT", JSHBDebuffFrames[i], "BOTTOMRIGHT", 4, -4)
		JSHBDebuffFrames[i].Stacks:SetFont(JSHB.fnts[JSHB.fnts.getFontIndex("Arial")][2], mF.db.debufficonsize*.4, "OUTLINE")
		JSHBDebuffFrames[i].Stacks:SetTextColor(1, 1, 0, 1)
		JSHBDebuffFrames[i].Stacks:Hide()
	end
end


local function updateMarkReminder()

	if not barLocked then return end

	if (not UnitExists("target")) or (UnitExists("target") and UnitIsFriend("player", "target")) or (UnitIsDeadOrGhost("target")) then

		JSHBMarkFrame:Hide()

	elseif checkForTargetDebuff(88691) then -- player cast only, dont detect other hunter's debuff (MFD)

		JSHBMarkFrame:Hide()

	else
		time = GetTime()
		tempVars[1], _, _, _, _, tempVars[2], tempVars[3] = UnitAura("target", GetSpellInfo(sp.huntersmark), nil, "HARMFUL") -- Any hunter's mark, not just player!

		-- Mark present and time is above threshold of 30s
		if tempVars[1] and ((tempVars[3] - time) > 30) then

			-- Mark present with 30s or more remaining duration on target
			JSHBMarkFrame:Hide()

		-- Mark present, didn't meet above condition, must be under 30s duration remaining.
		elseif tempVars[1] then
			if not JSHBMarkFrame.timer.enabled then

				JSHBMarkFrame:Show()
		
				local timer = JSHBMarkFrame.timer or jSBTimer_Create(JSHBMarkFrame)
				timer.start = time
				timer.duration = tempVars[3] - time
				timer.enabled = true
				timer.nextUpdate = 0
				timer:Show()
			end

		-- Mark is not present at all.
		else
			JSHBMarkFrame:Show()

			local timer = JSHBMarkFrame.timer or jSBTimer_Create(JSHBMarkFrame)
			timer.enabled = false
			timer:Hide()
		end
	end
end


local function setMarkReminder()

	if JSHBMarkFrame then
		JSHBMarkFrame:Hide()
		JSHBMarkFrame.active = false

		if JSHBMarkFrame.timer then
			JSHBMarkFrame.timer.enabled = nil
			JSHBMarkFrame.timer:Hide()
		end

		JSHBMarkFrame = nil
	end

	if not mF.db.enablehuntersmarkwarning then return end

	JSHBMarkFrame = CreateFrame("Frame", nil, UIParent)
	JSHBMarkFrame:SetWidth(mF.db.markIconSize)
	JSHBMarkFrame:SetHeight(mF.db.markIconSize)
	JSHBMarkFrame:SetPoint(mF.db.markAnchorPoint, 'UIParent', mF.db.markAnchorPointRelative, mF.db.markAnchorPointOffsetX, mF.db.markAnchorPointOffsetY)

	JSHBMarkFrame.Icon = JSHBMarkFrame:CreateTexture(nil, "BACKGROUND")
	JSHBMarkFrame.Icon:SetTexture(select(3, GetSpellInfo(sp.huntersmark)))
	JSHBMarkFrame.Icon:SetAllPoints(JSHBMarkFrame)

	-- Makes the frames look a bit more like tukui, plan to do this better later.
	if mF.db.enabletukui then
		JSHBMarkFrame.border = makeTukui(JSHBMarkFrame)
	end

	local timer = JSHBMarkFrame.timer or jSBTimer_Create(JSHBMarkFrame)
	timer.start = GetTime()
	timer.duration = 30 -- Start reminding player when Mark is at the 30s remaining point
	timer.enabled = false
	timer.nextUpdate = 0
	timer:Hide()

	JSHBMarkFrame:SetAlpha(1)
	JSHBMarkFrame:Hide()
end


local function updateTranqAlert()

	if not barLocked then return end

	if (not UnitExists("target")) or (UnitExists("target") and UnitIsFriend("player", "target")) then

		JSHBTranqFrame:Hide()
	else
		for x=1,#JSHB.tranqalerts do 

			tempVars[1], _, _, _, _, tempVars[2], tempVars[3] = UnitAura("target", GetSpellInfo(JSHB.tranqalerts[x][2]), nil, "HELPFUL") --13165 hawk for tesing

			if tempVars[1] then
				JSHBTranqFrame:Show()
				return
			end
		end

		JSHBTranqFrame:Hide()
	end
end


local function setTranqAlert()

	if JSHBTranqFrame then
		JSHBTranqFrame:Hide()
		JSHBTranqFrame = nil
	end

	if not mF.db.enabletranqalert then return end

	JSHBTranqFrame = CreateFrame("Frame", nil, mF)
	JSHBTranqFrame:SetWidth(mF.db.taiconsize)
	JSHBTranqFrame:SetHeight(mF.db.taiconsize)
	JSHBTranqFrame:SetPoint(mF.db.alertAnchorPoint, 'UIParent', mF.db.alertAnchorPointRelative, mF.db.alertAnchorPointOffsetX, mF.db.alertAnchorPointOffsetY)

	JSHBTranqFrame.Icon = JSHBTranqFrame:CreateTexture(nil, "BACKGROUND")
	JSHBTranqFrame.Icon:SetTexture(select(3, GetSpellInfo(19801))) -- Tranq Shot ID
	JSHBTranqFrame.Icon:SetAllPoints(JSHBTranqFrame)

	-- Makes the frames look a bit more like tukui, plan to do this better later.
	if mF.db.enabletukui then
		JSHBTranqFrame.border = makeTukui(JSHBTranqFrame)
	end
		
	JSHBTranqFrame.value = JSHBTranqFrame:CreateFontString(nil, "OVERLAY", mF)
	JSHBTranqFrame.value:SetJustifyH("CENTER")
	JSHBTranqFrame.value:SetPoint("BOTTOM", JSHBTranqFrame, "TOP", 0, 0)
	JSHBTranqFrame.value:SetFont(JSHB.fnts[JSHB.fnts.getFontIndex("Arial")][2], mF.db.taiconsize/2, "OUTLINE")
	JSHBTranqFrame.value:SetTextColor(1, 0, 0, 1)
	JSHBTranqFrame.value:SetText(JSHB.locale.tranq)

	JSHBTranqFrame:SetAlpha(1)
	JSHBTranqFrame:Hide()
end


local function setIconTimers()
	iconSize = mF.db.iconSize > 0 and (mF.db.iconSize) or (mF:GetHeight())
	currentTree = GetPrimaryTalentTree() -- 3 = sv, 2 = mm, 1 = bm
	
	for i=1,100 do
		if JSHBTimerFrames[i] then 
			JSHBTimerFrames[i]:Hide()
			JSHBTimerFrames[i].Icon = nil
			JSHBTimerFrames[i].value = nil --:SetAlpha(0)
			JSHBTimerFrames[i] = nil
		end
	end

	if not mF.db.enabletimers then return end

	if currentTree == nil then currentTree = 1 end

	for i=1,#mF.db.timers[JSHB.specs[currentTree]] do

		f = CreateFrame("Frame", nil, mF)
		f:SetWidth(iconSize)
		f:SetHeight(iconSize)
		f:SetPoint("LEFT", mF, "LEFT", 0, getIconOffset(mF.db.timers[JSHB.specs[currentTree]][i][4]))


		f.backdrop = f:CreateTexture(nil, "BACKGROUND", f)
		f.backdrop:SetAllPoints(f)
		f.backdrop:SetTexture(0, 0, 0, mF:GetAlpha())

		f.Icon = f:CreateTexture(nil,"BACKGROUND")
		f.Icon:SetTexture(select(3, GetSpellInfo(mF.db.timers[JSHB.specs[currentTree]][i][1])))
		f.Icon:SetAllPoints(f)

		-- Makes the frames look a bit more like tukui, plan to do this better later.
		if mF.db.enabletukui then
			f.border = makeTukui(f)
		end

		f.value = f:CreateFontString(nil, "OVERLAY")
		f.value:SetPoint('CENTER', (floor(f:GetWidth() + 0.5) / 19) * 1.5, 0) -- 1.5px offset based on 13px font and 19px standard icon width
		f.value:SetJustifyH("CENTER")
		f.value:SetJustifyV("CENTER")
		f.value:SetFont(JSHB.fnts[JSHB.fnts.getFontIndex(mF.db.timerfont)][2], mF.db.fontsizetimers, "OUTLINE")
		f.value:SetTextColor(1, 1, 1, 1)

		f.value:SetAlpha(0)

		JSHBTimerFrames[i] = f
	end
end


local function getAuraInfo(alias)
	if alias[2] and alias[3] then -- get duration left on player
		return checkForPlayerBuff(alias[1], true)
	elseif alias[2] and not alias[3] then -- get duration left on target
		return checkForTargetDebuff(alias[1])
	else -- get cooldown left, assume player and not target
		return checkForPlayerBuff(alias[1], false)
	end
end


local function updateTimers()
	currentTree = GetPrimaryTalentTree()
	iconSize = mF.db.iconSize > 0 and (mF.db.iconSize) or (mF:GetHeight())

	if currentTree == nil then currentTree = 1 end

	for i=1,#mF.db.timers[JSHB.specs[currentTree]] do
		tempVars[1], tempVars[2], tempVars[3] = getAuraInfo(mF.db.timers[JSHB.specs[currentTree]][i])

		if tempVars[1] and (not UnitIsDeadOrGhost("player")) then 
			JSHBTimerFrames[i]:SetPoint("LEFT", mF, "LEFT", getTimerXPos(tempVars[3], tempVars[2]),  getIconOffset(mF.db.timers[JSHB.specs[currentTree]][i][4]))

			if mF.db.timerfontposition == JSHB.pos.TOP or mF.db.timerfontposition == JSHB.pos.BOTTOM then

				if (mF.db.timers[JSHB.specs[currentTree]][i][4] == JSHB.pos.TOP) or (mF.db.timers[JSHB.specs[currentTree]][i][4] == JSHB.pos.ABOVE) or 
					((mF.db.timers[JSHB.specs[currentTree]][i][4] == JSHB.pos.CENTER) and (mF.db.timerfontposition == JSHB.pos.TOP)) then

					JSHBTimerFrames[i].value:SetPoint("BOTTOM", JSHBTimerFrames[i], "TOP", 0,  mF.db.enabletukuitimers and 3 or 1)
				else
					JSHBTimerFrames[i].value:SetPoint("TOP", JSHBTimerFrames[i], "BOTTOM", 0, mF.db.enabletukuitimers and 3 or 1)
				end
			elseif mF.db.timerfontposition == JSHB.pos.RIGHT then
				JSHBTimerFrames[i].value:SetPoint("LEFT", JSHBTimerFrames[i], "RIGHT", mF.db.enabletukuitimers and 3 or 1,  0)
			else
				JSHBTimerFrames[i].value:SetPoint("CENTER", JSHBTimerFrames[i], "CENTER", (floor(JSHBTimerFrames[i]:GetWidth() + 0.5) / 19) * 1.5, 0) -- 1.5px offset based on 13px font and 19px standard icon width
			end

			JSHBTimerFrames[i].value:SetText(formatTimeText(tempVars[3], mF.db.enabletimertenths, false))
			JSHBTimerFrames[i].value:SetAlpha(1)
			JSHBTimerFrames[i]:SetAlpha(mF:GetAlpha())
			JSHBTimerFrames[i].backdrop:SetAlpha(mF:GetAlpha())
		elseif (JSHBTimerFrames[i] ~= nil) and (JSHBTimerFrames[i] ~= nil) then
			JSHBTimerFrames[i]:SetAlpha(0)
			JSHBTimerFrames[i].value:SetAlpha(0)
		end
	end
end


local function getMainSpell()
	currentTree = GetPrimaryTalentTree()

	if currentTree == nil then currentTree = 1 end
	
	if currentTree == 3 then
		return select(4, GetSpellInfo(sp.explosiveshot)), sp.explosiveshot
	elseif currentTree == 2 then
		return select(4, GetSpellInfo(82928)), 82928 -- Aimed Shot (better than CS)
	else
		return select(4, GetSpellInfo(sp.killcommand)), sp.killcommand
	end
end


local function setTicks()
	if JSHBTick then
		JSHBTick:Hide()
		JSHBTick:SetParent(nil)
		JSHBTick = nil
	end

	if not mF.db.enablemaintick then return end	

	JSHBTick = CreateFrame("Frame", nil, mF)

	tickMin	= JSHBTick:CreateTexture(nil,"OVERLAY")
	tickMin:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	tickMin:SetWidth(10)
	tickMin:SetBlendMode("ADD")
	tickMin:SetHeight(mF:GetHeight() * 1.85)
end


local function updatePredictionAdjustment()
	-- Account for Termination talent extra focus
	if UnitHealth("target") / UnitHealthMax("target") <= 0.25 then 
		predictionAdjustment = select(5, GetTalentInfo(2, 12)) * terminationBase
	else
		predictionAdjustment = 0
	end
end


local function getPredictionColor()
	currentPower = UnitPower("player")

	-- class colored prediction is turned on
	if mF.db.classcoloredprediction then

		if mF.db.enablehighcolorwarning and ((currentPower / powerMax) >= mF.db.focushighthreshold) then
			-- class colored but over high threshold
			return mF.db.predictionbarcolorwarninghigh
		else
			-- class colored not over high threshold or high threshold is turned off
			return classColors
		end

	-- class colored prediction is not turned on
	elseif mF.db.enablehighcolorwarning and ((currentPower / powerMax) >= mF.db.focushighthreshold) then

		-- over the threshold enabled, set to the high warning color	
		return mF.db.predictionbarcolorwarninghigh
	else
		-- not over threshold, set color to the hard-defined color because class colored prediction is not on		
		return mF.db.predictionbarcolor
	end
end


local function getBarColor()
	currentPower = UnitPower("player")

	-- class colored is turned on
	if mF.db.classcolored then

		if mF.db.enablehighcolorwarning and ((currentPower / powerMax) >= mF.db.focushighthreshold) then

			-- class colored but over high threshold
			return mF.db.barcolorwarninghigh

		elseif currentPower < mainSpell then

			-- Focus is lower than main shot
			return mF.db.barcolorwarninglow

		else
			-- class colored not over high threshold or high threshold is turned off
			return classColors
		end

	-- class colored is not turned on
	elseif mF.db.enablehighcolorwarning and ((currentPower / powerMax) >= mF.db.focushighthreshold) then

		-- over the threshold enabled, set to the high warning color	
		return mF.db.barcolorwarninghigh

	elseif currentPower < mainSpell then

		-- Focus is lower than main shot
		return mF.db.barcolorwarninglow

	else
		-- Set color to the hard-defined color because class colored is not on		
		return mF.db.barcolor
	end
end


local function setPrediction()
	barColor = getPredictionColor()
	currentPower = UnitPower("player")

	if JSBPrediction then
		JSBPrediction:Hide()
		JSBPrediction:SetParent(nil)
		JSBPrediction = nil
	end

	if not mF.db.enableprediction then return end

	JSBPrediction = CreateFrame("StatusBar", nil, mF)

	JSBPrediction:SetStatusBarTexture(mF:GetStatusBarTexture():GetTexture()) -- Use the main bar's texture
	JSBPrediction:SetMinMaxValues(0, 1)
	JSBPrediction:SetValue(1)
	JSBPrediction:SetFrameLevel(mF:GetFrameLevel())
   
	updatePredictionAdjustment()

	JSBPrediction:SetSize((mF:GetWidth() / 100) * (predictionSpell + predictionAdjustment), mF:GetHeight())
   
	JSBPrediction:SetAlpha(0) -- hide

	if (currentPower + predictionSpell + predictionAdjustment) <= powerMax then
		JSBPrediction:SetStatusBarColor(barColor[1], barColor[2], barColor[3], 1)
	else
		JSBPrediction:SetSize((mF:GetWidth() / 100) * (powerMax - currentPower), mF:GetHeight())		
		JSBPrediction:SetStatusBarColor(mF.db.barcolorwarninglow[1], mF.db.barcolorwarninglow[2], mF.db.barcolorwarninglow[3], 1)
	end
end


local function setAutoShot()
	currentPower = UnitPower("player")

	if JSBAutoShotBar then
		JSBAutoShotBar.value:SetAlpha(0)
		JSBAutoShotBar:Hide()
		JSBAutoShotBar:SetParent(nil)
		JSBAutoShotBar = nil
	end

	if not mF.db.enableautoshotbar then return end

	JSBAutoShotBar = CreateFrame("StatusBar", nil, mF)

	JSBAutoShotBar:SetStatusBarTexture(mF:GetStatusBarTexture():GetTexture()) -- Use the main bar's texture
	JSBAutoShotBar:SetPoint("BOTTOMLEFT", mF, "BOTTOMLEFT", 0, 0) -- 2px up from bottom to be withing the main status bar
	JSBAutoShotBar:SetMinMaxValues(0, UnitRangedDamage("player"))
	JSBAutoShotBar:SetSize(mF.db.barWidth, 3) -- 3px in height (Don't want this to be annoying!)
	JSBAutoShotBar:SetValue(UnitRangedDamage("player"))
	JSBAutoShotBar:SetFrameLevel(mF:GetFrameLevel() + 1) -- raise strata one level so this is above the main bar
		
	JSBAutoShotBar:SetStatusBarColor(mF.db.autoshotbarcolor[1], mF.db.autoshotbarcolor[2], mF.db.autoshotbarcolor[3], 1)
	JSBAutoShotBar:SetAlpha(0) -- hide

	JSBAutoShotBar.value = JSBAutoShotBar:CreateFontString(nil, "OVERLAY")
	JSBAutoShotBar.value:SetFont(JSHB.fnts[JSHB.fnts.getFontIndex(mF.db.timerfont)][2], mF.db.fontsizetimers, "OUTLINE")
	JSBAutoShotBar.value:SetTextColor(1, 1, 1)
	JSBAutoShotBar.value:SetPoint("BOTTOMRIGHT", JSBAutoShotBar, "BOTTOMRIGHT", 1, 0)
	JSBAutoShotBar.value:SetJustifyH("BOTTOM")
	JSBAutoShotBar.value:SetAlpha(0)
end


local function updatePrediction()
	if not isCasting then return end -- No need to update if not casting

	barColor	= getPredictionColor()
	tempVars[1] 	= select(2, mF:GetMinMaxValues())
	tempVars[2] 	= mF:GetWidth() / (tempVars[1] / mF:GetValue())
	currentPower 	= UnitPower("player")

	updatePredictionAdjustment()

	JSBPrediction:SetSize((mF:GetWidth() / 100) * (predictionSpell + predictionAdjustment), mF:GetHeight())

	JSBPrediction:ClearAllPoints()
	JSBPrediction:SetPoint("LEFT", mF, "LEFT", tempVars[2], 0)

	if (currentPower + predictionSpell + predictionAdjustment) <= powerMax then
		if (currentPower + predictionSpell + predictionAdjustment) >= mainSpell then
			JSBPrediction:SetStatusBarColor(barColor[1], barColor[2], barColor[3], 1)
		else
			JSBPrediction:SetStatusBarColor(mF.db.barcolorwarninglow[1], mF.db.barcolorwarninglow[2], mF.db.barcolorwarninglow[3], 1)
		end
	else
		JSBPrediction:SetSize((mF:GetWidth() / 100) * (powerMax - currentPower), mF:GetHeight())
		JSBPrediction:SetStatusBarColor(mF.db.barcolorwarninglow[1], mF.db.barcolorwarninglow[2], mF.db.barcolorwarninglow[3], 1)
	end

	if ((powerMax - currentPower) > 0) and (not UnitIsDeadOrGhost("player")) then
		JSBPrediction:SetAlpha(mF:GetAlpha() * 0.7) -- Show prediction
	else
		JSBPrediction:SetAlpha(0) -- Hide prediction
	end
end


local function updateAutoShot()
	currentTime = GetTime()
	currentPower = UnitPower("player")

	if not JSBAutoShotBar then return end

	if currentTime > autoShotEndTime then
		JSBAutoShotBar:SetAlpha(0) -- Hide
		JSBAutoShotBar.value:SetAlpha(0)
	else
		JSBAutoShotBar:SetValue(autoShotStartTime + (currentTime - autoShotStartTime))
		if mF.db.enableautoshottext then 
			JSBAutoShotBar.value:SetFormattedText("%.1f", autoShotEndTime - currentTime)
			JSBAutoShotBar.value:SetAlpha(mF:GetAlpha())
		else
			JSBAutoShotBar.value:SetAlpha(0)
		end
	
		if not UnitIsDeadOrGhost("player") then
			JSBAutoShotBar:SetAlpha(mF:GetAlpha()) -- Show it
		else
			JSBAutoShotBar:SetAlpha(0) -- Hide
		end
	end
end


function mF:CreateFrame()
	mF:SetStatusBarTexture(JSHB.tex[JSHB.tex.getTextureIndex(mF.db.bartexture)][2])
	mF:SetMinMaxValues(0, 1)
	mF:SetValue(0)

	mF.backdrop = mF:CreateTexture(nil, "BACKGROUND", mF)
	mF.backdrop:SetPoint("TOPLEFT", -2, 2)
	mF.backdrop:SetPoint("BOTTOMRIGHT", 2, -2)
	mF.backdrop:SetTexture(0, 0, 0, .5)

	mF.value = mF:CreateFontString(nil, "OVERLAY", mF)
	mF.value:SetJustifyH("CENTER")

	mF:SetScript("OnDragStart", mF.StartMoving)
	mF:SetScript("OnDragStop", mF.StopMovingOrSizing)
end


SlashCmdList.JSHB = function(msg, editbox)
	tempVars[1], tempVars[2] = msg:match("^(%S*)%s*(.-)$");
	tempVars[1] = tempVars[1]:lower()

	if tempVars[1] == "" then
		if not debug then
			print(loc.slashdesc1 .. strsub(JSHB.ver,7))
			print("/jsb config - " .. loc.slashdesc2)
			print("/jsb lock - " .. loc.slashdesc3)
			print("/jsb reset - " .. loc.slashdesc4)
		else
			print("Debug Info: N/A")
		end
	elseif tempVars[1] == "options" or tempVars[1] == "config" or tempVars[1] == "opt" or tempVars[1] == "o" then
		InterfaceOptionsFrame_OpenToCategory(opt)

	elseif tempVars[1] == "reset" then

			if not barLocked then 
				barLocked = not barLocked
				if barLocked then opt.enablebarlock:SetChecked(true) else opt.enablebarlock:SetChecked(false) end
				mF:ApplyLock()
			end

			local x, y
			for x,y in pairs(JSHB.defaults["main"]) do 
				mF.db[x] = y
			end

			JSHB.reconfigureAddon()

	elseif tempVars[1] == "lock" or tempVars[1] == "unlock" or tempVars[1] == "drag" or tempVars[1] == "move" or tempVars[1] == "l" then
		barLocked = not barLocked
		if barLocked then opt.enablebarlock:SetChecked(true) else opt.enablebarlock:SetChecked(false) end
		mF:ApplyLock()
	else
		print(loc.invalidoption)
	end
end


local function enableFrameUnlock(source, mover, moveText, w, h, v1, v2, x, y)
	if source[1] ~= nil then
		local i = 1
		while source[i] ~= nil do
			source[i]:Hide()
			i = i + 1
		end
	else
		source:Hide()
	end

	mover:SetWidth(w)
	mover:SetHeight(h)
	mover:ClearAllPoints()
	mover:SetPoint(mF.db[v1], 'UIParent', mF.db[v2], mF.db[x], mF.db[y])

	if not mover.backdrop then 
		mover.backdrop = mover:CreateTexture(nil, "BACKGROUND", mover)
		mover.backdrop:SetAllPoints(mover)
		mover.backdrop:SetTexture(moveColor[1], moveColor[2], moveColor[3], moveColor[4])
		mover.backdrop:SetAlpha(1)
		mover.backdrop:Show()

		mover.value = mover:CreateFontString(nil, "OVERLAY", mover)
		mover.value:SetJustifyH("CENTER")
		mover.value:SetPoint("BOTTOM", mover, "TOP", 0, 2)
		mover.value:SetFont(JSHB.fnts[JSHB.fnts.getFontIndex("Arial")][2], 15, "OUTLINE")
		mover.value:SetTextColor(1, 1, 1, 1)
		mover.value:SetText(moveText)
	end

	mover:Show()
	mover:EnableMouse(true)
	mover:RegisterForDrag("LeftButton", "RightButton")
	mover:SetScript("OnDragStart", mover.StartMoving)
	mover:SetScript("OnDragStop", mover.StopMovingOrSizing)
	mover:SetMovable(true)
end


local function enableFrameLock(mover, v1, v2, x, y, setupCaller)

	mF.db[v1], _, mF.db[v2], mF.db[x], mF.db[y] = mover:GetPoint()

	mover:StopMovingOrSizing()
	mover:SetMovable(false)
	mover:EnableMouse(false)
	mover:RegisterForDrag()
	mover:Hide()

	if setupCaller then setupCaller() end
end


function mF:ApplyLock()

	if barLocked then -- LOCK

		print(loc.nowlocked)

		tempVars[1], _, tempVars[2], tempVars[3], tempVars[4] = mF:GetPoint()

		mF.db.anchorPoint 		= tempVars[1]
		mF.db.anchorPointRelative 	= tempVars[2]
		mF.db.anchorPointOffsetX 	= tempVars[3]
		mF.db.anchorPointOffsetY 	= tempVars[4]

		mF:StopMovingOrSizing()		
		mF:SetMovable(false)
		mF:EnableMouse(false)
		mF:RegisterForDrag()

		mF.backdrop:SetTexture(0, 0, 0, mF.db.alphabackdrop)

		if mF.db.enabletranqalert then
			enableFrameLock(JSHB.anchorFrame.tranqAlert, "alertAnchorPoint", "alertAnchorPointRelative", "alertAnchorPointOffsetX", "alertAnchorPointOffsetY", setTranqAlert)
		end

		if mF.db.enablehuntersmarkwarning then
			enableFrameLock(JSHB.anchorFrame.markReminder, "markAnchorPoint", "markAnchorPointRelative", "markAnchorPointOffsetX", "markAnchorPointOffsetY", setMarkReminder)
		end

		if mF.db.enablecctimers then
			enableFrameLock(JSHB.anchorFrame.ccIcons, "ccAnchorPoint", "ccAnchorPointRelative", "ccAnchorPointOffsetX", "ccAnchorPointOffsetY", setCCTimers)
		end

		if mF.db.enabledebuffalert then
			enableFrameLock(JSHB.anchorFrame.debuffAlert, "debuffAnchorPoint", "debuffAnchorPointRelative", "debuffAnchorPointOffsetX", "debuffAnchorPointOffsetY", setDebuffAlert)
		end

	else -- UNLOCK

		print(loc.nowunlocked)

		mF:SetAlpha(1)
		mF:SetMovable(true)
		mF:EnableMouse(true)
		mF:RegisterForDrag("LeftButton", "RightButton")

		mF.backdrop:SetTexture(moveColor[1], moveColor[2], moveColor[3], moveColor[4])

		if mF.db.enabletranqalert then
			enableFrameUnlock(JSHBTranqFrame, JSHB.anchorFrame.tranqAlert, JSHB.locale.movetranqalert, mF.db.taiconsize, mF.db.taiconsize,
				"alertAnchorPoint", "alertAnchorPointRelative", "alertAnchorPointOffsetX", "alertAnchorPointOffsetY")
		end

		if mF.db.enablehuntersmarkwarning then
			enableFrameUnlock(JSHBMarkFrame, JSHB.anchorFrame.markReminder, JSHB.locale.movemarkreminder, mF.db.markIconSize, mF.db.markIconSize,
				"markAnchorPoint", "markAnchorPointRelative", "markAnchorPointOffsetX", "markAnchorPointOffsetY")
		end

		if mF.db.enablecctimers then
			enableFrameUnlock(JSHBCCFrames, JSHB.anchorFrame.ccIcons, JSHB.locale.movecctimers, mF.db.cCIconSize, mF.db.cCIconSize,
				"ccAnchorPoint", "ccAnchorPointRelative", "ccAnchorPointOffsetX", "ccAnchorPointOffsetY")
		end

		if mF.db.enabledebuffalert then
			enableFrameUnlock(JSHBDebuffFrames, JSHB.anchorFrame.debuffAlert, JSHB.locale.movedebuffalert, mF.db.debufficonsize, mF.db.debufficonsize,
				"debuffAnchorPoint", "debuffAnchorPointRelative", "debuffAnchorPointOffsetX", "debuffAnchorPointOffsetY")
		end
	end
end


function mF:ApplyOptions()
	barColor = getBarColor()
	
	-- Makes the frames look a bit more like tukui, plan to do this better later.
	if mF.border then
		mF.border:Hide()
		mF.border:SetParent(nil)
		mF.border = nil
	end

	if mF.db.enabletukui then
		mF.border = makeTukui(mF, true)
	end

	mF.backdrop:SetTexture(0, 0, 0, mF.db.alphabackdrop)
	mF:SetStatusBarTexture(JSHB.tex[JSHB.tex.getTextureIndex(mF.db.bartexture)][2])
	mF:SetMinMaxValues(0, UnitPowerMax("player") and UnitPowerMax("player") or 100)
	
	mF:SetStatusBarColor(barColor[1], barColor[2], barColor[3], 1)
	mF:ClearAllPoints()
	mF:SetSize(mF.db.barWidth, mF.db.barHeight)
	mF:SetPoint(mF.db.anchorPoint, 'UIParent', mF.db.anchorPointRelative, mF.db.anchorPointOffsetX, mF.db.anchorPointOffsetY)

	mF.value:SetPoint("CENTER", mF, "CENTER", 0, (mF.db.enableautoshotbar == true) and 2 or 0)
	mF.value:SetFont(JSHB.fnts[JSHB.fnts.getFontIndex(mF.db.barfont)][2], mF.db.fontsize, mF.db.fontoutlined and "OUTLINE" or "")

	mF.value:SetTextColor(1, 1, 1, 1)

	setTicks()
	setAutoShot()
	setPrediction()
	setIconTimers()
	setCCTimers()
	setMarkReminder()
	setTranqAlert()
	setDebuffAlert()
end


JSHB.reconfigureAddon = function()
	mF:ApplyOptions()
end


local function updateJSHunterBar()
	barColor = getBarColor()
	tempVars[1] = mF:GetWidth() / select(2, mF:GetMinMaxValues())

	currentPower = UnitPower("player")
	mainSpell = getMainSpell()

	mF:SetValue(currentPower)
	mF.value:SetText(currentPower)

	mF:SetStatusBarColor(barColor[1], barColor[2], barColor[3], 1)

	if (currentPower == 0) or (UnitIsDeadOrGhost("player")) then
		if barLocked then 
			mF:SetAlpha(combatActive and mF.db.alphazero or mF.db.alphazeroooc) 
		end
	else
		if currentPower == powerMax then
			if barLocked then 
				mF:SetAlpha(combatActive and mF.db.alphamax or mF.db.alphamaxooc)
			end
		else
			if barLocked then mF:SetAlpha(combatActive and mF.db.alphanorm or mF.db.alphanormooc) end
		end
	end

	if mF.db.enablemaintick then 
		tickMin:SetPoint("LEFT", mF, "LEFT", mainSpell * tempVars[1] - 5, 0)

		if currentPower >= mainSpell then
			tickMin:SetVertexColor(barColor[1], barColor[2], barColor[3], 1)
		else
			tickMin:SetVertexColor(mF.db.barcolorwarninglow[1], mF.db.barcolorwarninglow[2], mF.db.barcolorwarninglow[3], 1)
		end

		tickMin:Show()
	end
end


mF:RegisterEvent("PLAYER_ENTERING_WORLD")
mF:RegisterEvent("ADDON_LOADED")
mF:RegisterEvent('UNIT_CONNECTION')
mF:RegisterEvent('UNIT_MAXPOWER')
mF:RegisterEvent("UNIT_POWER")
mF:RegisterEvent("UNIT_SPELLCAST_START")
mF:RegisterEvent("UNIT_SPELLCAST_STOP")
mF:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
mF:RegisterEvent("UNIT_SPELLCAST_FAILED")
mF:RegisterEvent("PLAYER_REGEN_ENABLED")
mF:RegisterEvent("PLAYER_REGEN_DISABLED")
mF:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
mF:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")


mF:SetScript("OnUpdate", function(self, elapsedTime)
	lastUpdate = lastUpdate + elapsedTime

	if lastUpdate > updateInterval then
		lastUpdate = 0
		updateJSHunterBar()
		if mF.db.enableprediction then updatePrediction() end
		if mF.db.enabletimers then updateTimers() end
		if mF.db.enablecctimers then repositionCCTimers() end
		if mF.db.enabledebuffalert then repositionDebuffAlert() end
		updateAutoShot()
		if mF.db.enablehuntersmarkwarning then updateMarkReminder() end
		if mF.db.enabletranqalert then updateTranqAlert() end
	end
end)


local function checkNotEqual(val1, val2)
	if ((not val1) and val2) or (val1 and (not val2)) then return true else	return false end
end


JSHB.updateSettings = function()

	-- Default pane
	if checkNotEqual(barLocked, opt.enablebarlock:GetChecked()) then
		barLocked = not barLocked
		mF:ApplyLock()
	end

	-- General pane
	mF.db.enableautoshotbar = opt.general.enableautoshotbar:GetChecked() and true or false
	mF.db.enableautoshottext = opt.general.enableautoshottext:GetChecked() and true or false
	mF.db.enablemaintick = opt.general.enablemaintick:GetChecked() and true or false
	mF.db.enablehuntersmarkwarning = opt.general.enablehuntersmarkwarning:GetChecked() and true or false
	mF.db.enablecctimers = opt.general.enablecctimers:GetChecked() and true or false
	mF.db.enableprediction = opt.general.enableprediction:GetChecked() and true or false
	mF.db.enabletimers = opt.general.enabletimers:GetChecked() and true or false
	mF.db.timerfontposition = UIDropDownMenu_GetSelectedValue(opt.general.timerfontposition.dropdown)
	mF.db.enabletimerstext = opt.general.enabletimerstext:GetChecked() and true or false
	mF.db.enabletranqannounce = opt.general.enabletranqannounce:GetChecked() and true or false
	mF.db.tranqannouncechannel = UIDropDownMenu_GetSelectedValue(opt.general.tranqannouncechannel.dropdown)
	mF.db.enabletranqalert = opt.general.enabletranqalert:GetChecked() and true or false
	mF.db.enabletimertenths = opt.general.enabletimertenths:GetChecked() and true or false
	mF.db.enabledebuffalert = opt.general.enabledebuffalert:GetChecked() and true or false

	-- Style & Style pane
	mF.db.classcolored = opt.stylesize.classcolored:GetChecked() and true or false
	mF.db.classcoloredprediction = opt.stylesize.classcoloredprediction:GetChecked() and true or false
	mF.db.enablehighcolorwarning = opt.stylesize.enablehighcolorwarning:GetChecked() and true or false
	mF.db.enabletukui = opt.stylesize.enabletukui:GetChecked() and true or false
	mF.db.enabletukuitimers = opt.stylesize.enabletukuitimers:GetChecked() and true or false
	mF.db.focushighthreshold = opt.stylesize.focushighthreshold:GetValue() / 100
	mF.db.alphazeroooc = opt.stylesize.alphazeroooc:GetValue() / 100
	mF.db.alphamaxooc = opt.stylesize.alphamaxooc:GetValue() / 100
	mF.db.alphanormooc = opt.stylesize.alphanormooc:GetValue() / 100
	mF.db.alphazero = opt.stylesize.alphazero:GetValue() / 100
	mF.db.alphamax = opt.stylesize.alphamax:GetValue() / 100
	mF.db.alphanorm = opt.stylesize.alphanorm:GetValue() / 100

	mF.db.barWidth = opt.stylesize.barwidth:GetValue()
	mF.db.barHeight = opt.stylesize.barheight:GetValue()
	mF.db.iconSize = opt.stylesize.iconsize:GetValue()
	if (mF.db.iconSize > 0) and (mF.db.iconSize < 8) then mF.db.iconSize = 0 end
	mF.db.cCIconSize = opt.stylesize.cciconsize:GetValue()
	mF.db.markIconSize = opt.stylesize.markiconsize:GetValue()
	mF.db.taiconsize = opt.stylesize.taiconsize:GetValue()
	mF.db.debufficonsize = opt.stylesize.debufficonsize:GetValue()
	mF.db.alphabackdrop = opt.stylesize.alphabackdrop:GetValue() / 100

	mF.db.barcolor = { opt.colors.barcolor:GetColorRGB() }
	mF.db.barcolorwarninglow = { opt.colors.barcolorwarninglow:GetColorRGB() }
	mF.db.barcolorwarninghigh = { opt.colors.barcolorwarninghigh:GetColorRGB() }
	mF.db.predictionbarcolorwarninghigh = { opt.colors.predictionbarcolorwarninghigh:GetColorRGB() }
	mF.db.predictionbarcolor = { opt.colors.predictionbarcolor:GetColorRGB() }
	mF.db.autoshotbarcolor = { opt.colors.autoshotbarcolor:GetColorRGB() }

	-- Font & Texture pane
	mF.db.barfont = opt.fontstextures.barfont:GetValue()
	mF.db.timerfont = opt.fontstextures.timerfont:GetValue()
	mF.db.bartexture = opt.fontstextures.bartexture:GetValue()
	mF.db.fontsize = opt.fontstextures.fontsize:GetValue()
	mF.db.fontsizetimers = opt.fontstextures.fontsizetimers:GetValue()
	mF.db.fontoutlined = opt.fontstextures.fontoutlined:GetChecked() and true or false

	-- Spec timers pane
	mF.db.timers["bm"] = opt.bm.Timers
	mF.db.timers["mm"] = opt.mm.Timers
	mF.db.timers["sv"] = opt.sv.Timers

	JSHB.reconfigureAddon()
end


local function getMatchTableVal(table, colMatch, colReturn, toMatch)
	local i
	for i=1,#table do
		if table[i][colMatch] == toMatch then return table[i][colReturn] end
	end
	return nil
end


JSHB.setupOptionsPane = function()

	-- Default pane
	if barLocked then opt.enablebarlock:SetChecked(true) else opt.enablebarlock:SetChecked(false) end

	-- General pane
	if mF.db.enableautoshotbar then opt.general.enableautoshotbar:SetChecked(true) else opt.general.enableautoshotbar:SetChecked(false) end
	if mF.db.enableautoshottext then opt.general.enableautoshottext:SetChecked(true) else opt.general.enableautoshottext:SetChecked(false) end
	if mF.db.enablemaintick then opt.general.enablemaintick:SetChecked(true) else opt.general.enablemaintick:SetChecked(false) end
	if mF.db.enablehuntersmarkwarning then opt.general.enablehuntersmarkwarning:SetChecked(true) else opt.general.enablehuntersmarkwarning:SetChecked(false) end
	if mF.db.enabletranqannounce then opt.general.enabletranqannounce:SetChecked(true) else opt.general.enabletranqannounce:SetChecked(false) end

	UIDropDownMenu_SetSelectedValue(opt.general.tranqannouncechannel.dropdown, mF.db.tranqannouncechannel or 1) -- the or 1 accounts for feature added after-the-fact
	opt.general.tranqannouncechannel.valueText:SetText(getMatchTableVal(JSHB.tranqannouncechannel, 2, 1, mF.db.tranqannouncechannel))

	if mF.db.enabletranqalert then opt.general.enabletranqalert:SetChecked(true) else opt.general.enabletranqalert:SetChecked(false) end
	if mF.db.enablecctimers then opt.general.enablecctimers:SetChecked(true) else opt.general.enablecctimers:SetChecked(false) end
	if mF.db.enableprediction then opt.general.enableprediction:SetChecked(true) else opt.general.enableprediction:SetChecked(false) end
	if mF.db.enabletimers then opt.general.enabletimers:SetChecked(true) else opt.general.enabletimers:SetChecked(false) end

	UIDropDownMenu_SetSelectedValue(opt.general.timerfontposition.dropdown, mF.db.timerfontposition)
	opt.general.timerfontposition.valueText:SetText(getMatchTableVal(JSHB.timerfontpositions, 2, 1, mF.db.timerfontposition))

	if mF.db.enabletimerstext then opt.general.enabletimerstext:SetChecked(true) else opt.general.enabletimerstext:SetChecked(false) end
	if mF.db.enabletimertenths then opt.general.enabletimertenths:SetChecked(true) else opt.general.enabletimertenths:SetChecked(false) end
	if mF.db.enabledebuffalert then opt.general.enabledebuffalert:SetChecked(true) else opt.general.enabledebuffalert:SetChecked(false) end

	-- Style & Style pane
	if mF.db.classcolored then opt.stylesize.classcolored:SetChecked(true) else opt.stylesize.classcolored:SetChecked(false) end
	if mF.db.classcoloredprediction then opt.stylesize.classcoloredprediction:SetChecked(true) else opt.stylesize.classcoloredprediction:SetChecked(false) end
	if mF.db.enablehighcolorwarning then opt.stylesize.enablehighcolorwarning:SetChecked(true) else opt.stylesize.enablehighcolorwarning:SetChecked(false) end
	opt.stylesize.focushighthreshold:SetValue(mF.db.focushighthreshold * 100)
	if mF.db.enabletukui then opt.stylesize.enabletukui:SetChecked(true) else opt.stylesize.enabletukui:SetChecked(false) end
	if mF.db.enabletukuitimers then opt.stylesize.enabletukuitimers:SetChecked(true) else opt.stylesize.enabletukuitimers:SetChecked(false) end
	opt.stylesize.barwidth:SetValue(mF.db.barWidth)
	opt.stylesize.barheight:SetValue(mF.db.barHeight)
	opt.stylesize.iconsize:SetValue(mF.db.iconSize)
	opt.stylesize.cciconsize:SetValue(mF.db.cCIconSize)
	opt.stylesize.markiconsize:SetValue(mF.db.markIconSize)
	opt.stylesize.taiconsize:SetValue(mF.db.taiconsize)
	opt.stylesize.debufficonsize:SetValue(mF.db.debufficonsize)
	opt.stylesize.alphabackdrop:SetValue(mF.db.alphabackdrop * 100)
	opt.stylesize.alphazeroooc:SetValue(mF.db.alphazeroooc * 100)
	opt.stylesize.alphamaxooc:SetValue(mF.db.alphamaxooc * 100)
	opt.stylesize.alphanormooc:SetValue(mF.db.alphanormooc * 100)
	opt.stylesize.alphazero:SetValue(mF.db.alphazero * 100)
	opt.stylesize.alphamax:SetValue(mF.db.alphamax * 100)
	opt.stylesize.alphanorm:SetValue(mF.db.alphanorm * 100)

	-- Font & Texture pane
	opt.fontstextures.barfont:SetValue(mF.db.barfont)
	opt.fontstextures.timerfont:SetValue(mF.db.timerfont)
	opt.fontstextures.bartexture:SetValue(mF.db.bartexture)
	opt.fontstextures.fontsize:SetValue(mF.db.fontsize)
	opt.fontstextures.fontsizetimers:SetValue(mF.db.fontsizetimers)
	if mF.db.fontoutlined then opt.fontstextures.fontoutlined:SetChecked(true) else opt.fontstextures.fontoutlined:SetChecked(false) end


	-- Colors pane
	opt.colors.barcolor:SetColorRGB(unpack(mF.db.barcolor))
	opt.colors.barcolorwarninglow:SetColorRGB(unpack(mF.db.barcolorwarninglow))
	opt.colors.barcolorwarninghigh:SetColorRGB(unpack(mF.db.barcolorwarninghigh))
	opt.colors.predictionbarcolorwarninghigh:SetColorRGB(unpack(mF.db.predictionbarcolorwarninghigh))
	opt.colors.predictionbarcolor:SetColorRGB(unpack(mF.db.predictionbarcolor))
	opt.colors.autoshotbarcolor:SetColorRGB(unpack(mF.db.autoshotbarcolor))

	-- Spec timers pane
	opt.bm.Timers = mF.db.timers["bm"]
	opt.mm.Timers = mF.db.timers["mm"]
	opt.sv.Timers = mF.db.timers["sv"]
end


mF:SetScript("OnEvent", function(self, event, ...)

	if event == "ADDON_LOADED" then

		local addon = ...
		if addon:lower() ~= "jshunterbar" then return end

		JSHB_SavedOptions = JSHB_SavedOptions
		if not JSHB_SavedOptions then JSHB_SavedOptions = {} end

		-- Compact version of configuration settings for new installs and checking variables of existing installs
		local x, y
		for x,y in pairs(JSHB.defaults["main"]) do
			if JSHB_SavedOptions[x] == nil then JSHB_SavedOptions[x] = y end
		end
		for x,y in pairs(JSHB.defaults["general"]) do
			if JSHB_SavedOptions[x] == nil then JSHB_SavedOptions[x] = y end
		end
		for x,y in pairs(JSHB.defaults["style"]) do
			if JSHB_SavedOptions[x] == nil then JSHB_SavedOptions[x] = y end
		end
		for x,y in pairs(JSHB.defaults["fontstextures"]) do
			if JSHB_SavedOptions[x] == nil then JSHB_SavedOptions[x] = y end
		end
		for x,y in pairs(JSHB.defaults["colors"]) do
			if JSHB_SavedOptions[x] == nil then JSHB_SavedOptions[x] = y end
		end

		if JSHB_SavedOptions.timers == nil then JSHB_SavedOptions.timers = {} end
		if JSHB_SavedOptions.timers["bm"] == nil then JSHB_SavedOptions.timers["bm"] = JSHB.defaults["bm"] end
		if JSHB_SavedOptions.timers["mm"] == nil then JSHB_SavedOptions.timers["mm"] = JSHB.defaults["mm"] end
		if JSHB_SavedOptions.timers["sv"] == nil then JSHB_SavedOptions.timers["sv"] = JSHB.defaults["sv"] end

		table.sort(JSHB_SavedOptions.timers["bm"], function(a,b) return select(1, GetSpellInfo(a[1]))<select(1, GetSpellInfo(b[1])) end)
		table.sort(JSHB_SavedOptions.timers["mm"], function(a,b) return select(1, GetSpellInfo(a[1]))<select(1, GetSpellInfo(b[1])) end)
		table.sort(JSHB_SavedOptions.timers["sv"], function(a,b) return select(1, GetSpellInfo(a[1]))<select(1, GetSpellInfo(b[1])) end)

		self.db = JSHB_SavedOptions
	
		opt = JSHB.options

		if IsAddOnLoaded("Tukui") then
			T, C, L = unpack(Tukui)
		end

		self:CreateFrame()

		self:UnregisterEvent("ADDON_LOADED")

	elseif event == "UNIT_SPELLCAST_START" then

		if select(1, ...) == "player" then

			spellCastID = select(5, ...)

			if spellCastID  == sp.steadyshot or spellCastID == sp.cobrashot then

				isCasting = true

				if mF.db.enableprediction then
					updatePrediction()
				end

			elseif spellCastID == 75 then -- Auto Shot

				updateAutoShot()
			end
		end

	elseif string.find(event, "UNIT_SPELLCAST_") then -- STOP / FAILED / SUCCEEDED all handled here

		if select(1, ...) == "player" then

			spellCastID = select(5, ...)
			if spellCastID  == sp.steadyshot or spellCastID == sp.cobrashot then

				isCasting = false
				if mF.db.enableprediction then
					JSBPrediction:SetAlpha(0) -- Hide prediction
					return
				end
			end

			if (event == "UNIT_SPELLCAST_SUCCEEDED") and (spellCastID == 75) and mF.db.enableautoshotbar then

				autoShotStartTime = GetTime()
				autoShotEndTime	= autoShotStartTime + UnitRangedDamage("player")

				if JSBAutoShotBar then

					JSBAutoShotBar:SetMinMaxValues(autoShotStartTime, autoShotEndTime)
					if mF.db.enableautoshottext then JSBAutoShotBar.value:SetText("") end
					JSBAutoShotBar:SetAlpha(mF:GetAlpha())
					updateAutoShot()
				end
			end
		end	
	
	elseif event == "PLAYER_REGEN_ENABLED" then

		combatActive = false

	elseif event == "PLAYER_REGEN_DISABLED" then

		combatActive = true

	elseif event == "PLAYER_ENTERING_WORLD" then

		JSHB.setupOptionsPane()
		JSHB.reconfigureAddon()
		powerMax = UnitPowerMax("player")
		playerGUID = UnitGUID("player")

	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then

		currentTree = GetPrimaryTalentTree()
		if currentTree == nil then currentTree = 1 end
		JSHB.reconfigureAddon()

	elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") then

		if mF.db.enablecctimers == true then

			if (select(2, ...) == "SPELL_AURA_APPLIED") and (select(3, select(1, ...)) == playerGUID) then

				if select(9, ...) == 3355 then -- Freezing trap Aura

					i = (bit.band(select(8, select(1, ...)), COMBATLOG_OBJECT_CONTROL_PLAYER) > 0) and 8 or (60 + (6 * select(5, GetTalentInfo(3, 5))))

					addCCTimer(sp.freezingtrap, select(6, select(1, ...)), i) -- account for trap mastery

				elseif select(9, ...) == sp.wyvernsting then

					addCCTimer(sp.wyvernsting, select(6, select(1, ...)), 30)
				end

			elseif (select(2, ...) == "SPELL_AURA_REFRESH") and (select(3, select(1, ...)) == playerGUID) then

				if select(9, ...) == 3355 then -- Freezing Trap Aura

					i = (bit.band(select(8, select(1, ...)), COMBATLOG_OBJECT_CONTROL_PLAYER) > 0) and 8 or (60 + (6 * select(5, GetTalentInfo(3, 5))))
					refreshCCTimer(sp.freezingtrap, select(6, select(1, ...)), i) -- account for trap mastery

				end
			elseif (select(2, ...) == "SPELL_AURA_REMOVED") and (select(3, select(1, ...)) == playerGUID) then

				if select(9, ...) == 3355 then -- Freezing Trap Aura

					stopCCTimer(sp.freezingtrap, select(6, select(1, ...)))

				elseif select(9, ...) == sp.wyvernsting then

					stopCCTimer(sp.wyvernsting, select(6, select(1, ...)))
				end
			end
		end

		if mF.db.enabletranqannounce == true then

			if (select(2, ...) == "SPELL_DISPEL") and (select(3, select(1, ...)) == playerGUID) and (select(6, select(1, ...)) ~= UnitGUID("pet")) then

				SendChatMessage(loc.tranqremoved .. "|cff71d5ff|Hspell:" .. select(2, select(11, ...)) .. "|h[" .. select(2, select(12, ...)) .. "]|h|r"
						.. loc.tranqfrom..select(7, select(1, ...))..".", getChatChan())
			end
		end

		if mF.db.enabledebuffalert then

			tempVars[10] = select(9, ...)
			if (select(2, ...) == "SPELL_AURA_APPLIED") and (select(6, select(1, ...)) == playerGUID) then

				if getMatchTableVal(JSHB.debuffalerts, 2, 2, tempVars[10]) then

					addDebuffAlert(tempVars[10], select(6, UnitAura("player", GetSpellInfo(tempVars[10]), nil, "HARMFUL")),
						select(4, UnitAura("player", GetSpellInfo(tempVars[10]), nil, "HELPFUL")))

				end

			elseif (select(2, ...) == "SPELL_AURA_REFRESH") and (select(6, select(1, ...)) == playerGUID) then

				if getMatchTableVal(JSHB.debuffalerts, 2, 2, tempVars[10]) then

					refreshDebuffAlert(tempVars[10], select(6, UnitAura("player", GetSpellInfo(tempVars[10]), nil, "HARMFUL")),
						select(4, UnitAura("player", GetSpellInfo(tempVars[10]), nil, "HELPFUL")))

				end

			elseif (select(2, ...) == "SPELL_AURA_REMOVED") and (select(6, select(1, ...)) == playerGUID) then

				if getMatchTableVal(JSHB.debuffalerts, 2, 2, tempVars[10]) then

					stopDebuffAlert(tempVars[10])

				end
			end
		end

	else
		powerMax_new = UnitPowerMax("player")

		if powerMax_new ~= powerMax then
			powerMax = powerMax_new
			mF:SetMinMaxValues(0, powerMax)
		end
	end
end)
