-- Variables declaration

JSHB.ver = GetAddOnMetadata( ..., "Version" ):match( "^([%d.]+)" )

JSHB.spellid = {
	["bestialwrath"]		= 19574,
	["trollberserking"]		= 26297,
	["blackarrow"]			= 3674,
	["bloodfury"]			= 20572,
	["callofthewild"]		= 53434,
	["camouflage"]			= 51755,
	["chimerashot"]			= 53209,
	["concussiveshot"]		= 5116,
	["cobrashot"] 			= 77767,
	["warrior_deathwish"]		= 12292,
	["deterrence"] 			= 19263,
	["disengage"] 			= 781,
	["explosiveshot"] 		= 53301,
	["explosivetrap"] 		= 13813,
	["feigndeath"] 			= 5384,
	["fervor"]			= 82726,
	["frenzy"]			= 19623,
	["fireproc"]			= 82926,
	["focusfire"]			= 82692,
	["freezingtrap"]		= 1499,
	["paladin_handofprotection"]	= 1022,
	["huntersmark"]			= 56303,
	["immolationtrap"]		= 13795,
	["intimidation"]		= 19577,
	["icetrap"]			= 13809,
	["improvedsteadyshot"]		= 53220,
	["killcommand"] 		= 34026,
	["killingstreak"]		= 94007, 
	["killshot"] 			= 53351,
	["locknload"] 			= 56453,
	["masterscall"]			= 53271,
	["mendpet"]			= 136,
	["misdirection"] 		= 34477,
	["readiness"]			= 23989,
	["readysetaim"]			= 82925,
	["rapidfire"]			= 3045,
	["raptorstrike"]		= 2973,
	["resistanceisfutile"]		= 82897,
	["scattershot"]			= 19503,
	["serpentsting"]		= 1978,
	["silencingshot"]		= 34490,
	["snaketrap"]			= 34600,
	["steadyshot"]			= 56641,
	["thebeastwithin"]		= 34692,
	["traplauncher"] 		= 77769,
	["widowvenom"]			= 82654,
	["wingclip"]			= 2974,
	["wyvernsting"]			= 19386,
}

JSHB.tranqalerts = {
	{ 0, 92967 }, -- BWD: Maloriak 
	{ 0, 80084 }, -- BWD: Maimgor
	{ 0, 80158 }, --  SC: Warbringers
	{ 0, 91543 }, -- BWD: Arcanotron - Power Conversion (Mage should Spell Steal this, in case you dont have one purge or tranq)
}

JSHB.debuffalerts = {
	{ 0, 91902 }, -- BWD: Pyreclaw - 25m
	{ 0, 80127 }, -- BWD: Pyreclaw - 10m
	{ 0, 80094 }, -- BWD: Toxitron - Fixate 
	{ 0, 79888 }, -- BWD: Electron - Lightning Conductor
	{ 0, 92051 }, -- BWD: Electron - Shadow Conductor (92135, 92053 are other spell id's)
	{ 0, 92973 }, -- BWD: Maloriak - Consuming Flames
	{ 0, 78617 }, -- BWD: Maloriak - Fixate
	{ 0, 78075 }, -- BWD: Atramedes - Sonic Breath
	{ 0, 82665 }, -- BOT: Feludius - Heart of Ice
	{ 0, 82762 }, -- BOT: Feludius - Waterlogged
	{ 0, 82660 }, -- BOT: Ignacious - Burning Blood
	{ 0, 83099 }, -- BOT: Arion - Lightning Rod
-- TESTING!
--	{ 0, 8050  }, -- Shaman dot (for testing!)
--	{ 0, 589   }, -- Shadow Word Pain (for testing!)
--	{ 0, 1978  }, -- Serpent Sting (for testing!)
--	{ 0, 95809 }, -- Insanity (Ancient Hysteria) (for testing!)

}

JSHB.pos = {
	["TOP"]		= 1,
	["BOTTOM"]	= 2,
	["ABOVE"]	= 3, 
	["BELOW"]	= 4,
	["CENTER"]	= 5,
	["LEFT"]	= 6,
	["RIGHT"]	= 7,
}

JSHB.fnts = {
	{ "Arial", 		"Fonts\\ARIALN.TTF" },
	{ "Big Noodle", 	"Interface\\AddOns\\JSHunterBar\\media\\fonts\\BigNoodle.ttf" },
	{ "Friz Quadrata TT", 	"Fonts\\FRIZQT__.TTF" },
	{ "Morpheus", 		"Fonts\\MORPHEUS.ttf" },
	{ "Skurri", 		"Fonts\\skurri.ttf" }
}

JSHB.fnts.getFontIndex = function(name)
	local i
	for i=1,#JSHB.fnts do
		if JSHB.fnts[i][1] == name then return i end
	end
	return JSHB.fnts.getFontIndex("Arial") -- Default
end

JSHB.tex = {
	{ "Blank", 	[=[Interface\AddOns\JSHunterBar\media\textures\blank.tga]=] },
	{ "Blizzard",	[=[Interface\TargetingFrame\UI-StatusBar]=] },
	{ "Solid", 	[=[Interface\AddOns\JSHunterBar\media\textures\solid.tga]=] },
}

JSHB.tex.getTextureIndex = function(name)
	local i
	for i=1,#JSHB.tex do
		if JSHB.tex[i][1] == name then return i end
	end
	return JSHB.tex.getTextureIndex("Blizzard") -- Default
end

JSHB.specs = { "bm", "mm", "sv" } -- in order

JSHB.timerpositions = { 
	{ JSHB.locale.posabove, 	JSHB.pos.ABOVE },
	{ JSHB.locale.postop, 		JSHB.pos.TOP },
	{ JSHB.locale.poscenter, 	JSHB.pos.CENTER },
	{ JSHB.locale.posbottom, 	JSHB.pos.BOTTOM },
	{ JSHB.locale.posbelow, 	JSHB.pos.BELOW }
}

JSHB.tranqannouncechannel = {
	{ JSHB.locale.chan_auto, 		1 },
	{ JSHB.locale.chan_raid, 		"RAID" },
	{ JSHB.locale.chan_yell, 		"YELL" },
	{ JSHB.locale.chan_officer, 		"OFFICER" },
	{ JSHB.locale.chan_guild, 		"GUILD" },
	{ JSHB.locale.chan_battleground,	"BATTLEGROUND" },
	{ JSHB.locale.chan_party, 		"PARTY" },
	{ JSHB.locale.chan_emote, 		"EMOTE" },
	{ JSHB.locale.chan_say, 		"SAY" },
}

JSHB.timerpositions.getValueName = function(val)
	local i
	for i=1,#JSHB.timerpositions do
		if JSHB.timerpositions[i][2] == val then return JSHB.timerpositions[i][1] end
	end
	return nil -- Default
end

JSHB.timerfontpositions = { 
	{ JSHB.locale.posright, 	JSHB.pos.RIGHT },
	{ JSHB.locale.poscenter, 	JSHB.pos.CENTER },
	{ JSHB.locale.postopbottom,	JSHB.pos.TOP },
}

JSHB.defaults = {

	["main"] = {
		["anchorPoint"]				= "CENTER",
		["anchorPointRelative"] 		= "CENTER",
		["anchorPointOffsetX"] 			= 0,
		["anchorPointOffsetY"] 			= -170,

		["alertAnchorPoint"] 			= "CENTER",
		["alertAnchorPointRelative"] 		= "CENTER",
		["alertAnchorPointOffsetX"] 		= 100,
		["alertAnchorPointOffsetY"] 		= 0,

		["markAnchorPoint"] 			= "CENTER",
		["markAnchorPointRelative"] 		= "CENTER",
		["markAnchorPointOffsetX"] 		= 50,
		["markAnchorPointOffsetY"] 		= -70,

		["ccAnchorPoint"] 			= "CENTER",
		["ccAnchorPointRelative"] 		= "CENTER",
		["ccAnchorPointOffsetX"] 		= -190,
		["ccAnchorPointOffsetY"] 		= -170,

		["debuffAnchorPoint"] 			= "CENTER",
		["debuffAnchorPointRelative"] 		= "CENTER",
		["debuffAnchorPointOffsetX"] 		= -50,
		["debuffAnchorPointOffsetY"] 		= -70,

		["cdIconAnchorPoint"] 			= "CENTER",
		["cdIconAnchorPointRelative"]		= "CENTER",
		["cdIconAnchorPointOffsetX"] 		= 190,
		["cdIconAnchorPointOffsetY"] 		= -170,
	},

	["general"] = {
		["enableprediction"]			= true,
		["enableautoshotbar"]			= false,
		["enableautoshottext"]			= true,
		["enabletimers"]			= true,
		["timerfontposition"]			= JSHB.pos.RIGHT,
		["enablemaintick"]			= true,
		["enabletimerstext"]			= true,
		["enabletimertenths"]			= false,
		["enablecctimers"]			= true,
		["enablehuntersmarkwarning"]		= true,
		["enabletranqannounce"]			= true,
		["tranqannouncechannel"]		= 1,
		["enabletranqalert"]			= true,
		["enabledebuffalert"]			= true,
		["enablecdicons"]			= true,
	},

	["style"] = {
		["classcolored"]			= true,
		["classcoloredprediction"]		= true,
		["enablehighcolorwarning"]		= true,
		["enabletukui"]				= false,
		["enabletukuitimers"]			= false,
		["focushighthreshold"]			= 0.8,
		["barWidth"]				= 250,
		["barHeight"]				= 19,
		["iconSize"]				= 0,
		["cCIconSize"]				= 30,
		["markIconSize"]			= 30,
		["taiconsize"]				= 36,
		["alphabackdrop"]			= 0.5,
		["alphazeroooc"]			= 0,
		["alphamaxooc"]				= 0.1,
		["alphanormooc"]			= 0.5,
		["alphazero"]				= 0.1,
		["alphamax"]				= 0.9,
		["alphanorm"]				= 0.9,
		["debufficonsize"]			= 40,
	},

	["fontstextures"] = {
		["barfont"]				= "Big Noodle",
		["timerfont"]				= "Arial",
		["bartexture"]				= "Blizzard",
		["fontoutlined"]			= true,
		["fontsize"]				= 17,
		["fontsizetimers"]			= 13,
	},

	["colors"] = {
		["barcolor"] 				= {0.6, 0.6, 0.6},
		["barcolorwarninglow"]			= {1, 0, 0},
		["barcolorwarninghigh"]			= {1, 0.55, 0},
		["predictionbarcolorwarninghigh"]	= {1, 0.55, 0},
		["predictionbarcolor"]			= {0.6, 0.6, 0.6},
		["autoshotbarcolor"]			= {1, 1, 1},
	},


	--  1st field = spell ID
	--  2nd field = true to track duration up or false for cooldown
	--  3rd field = true for player false for target
	--  4th field = position of the icon relative to the bar
	["bm"] = {
		{ JSHB.spellid.serpentsting, 		true, 	false, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.widowvenom,	 	true, 	false, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.rapidfire, 		true, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.fervor, 			false, 	true, 	JSHB.pos.BELOW },
		{ JSHB.spellid.freezingtrap,		false, 	true, 	JSHB.pos.BELOW },
		{ JSHB.spellid.bestialwrath,		true, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.bestialwrath,		false, 	true, 	JSHB.pos.BELOW },
		{ JSHB.spellid.bloodfury,		true, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.bloodfury,		false, 	true, 	JSHB.pos.BELOW },
	},

	["mm"] = {
		{ JSHB.spellid.improvedsteadyshot, 	true, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.serpentsting, 		true, 	false, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.widowvenom,	 	true, 	false, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.rapidfire, 		true, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.freezingtrap,		false, 	true, 	JSHB.pos.BELOW },
		{ JSHB.spellid.bloodfury,		true, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.bloodfury,		false, 	true, 	JSHB.pos.BELOW },
	},

	["sv"] = {
		{ JSHB.spellid.blackarrow, 		false, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.serpentsting, 		true, 	false, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.rapidfire, 		true, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.widowvenom,	 	true, 	false, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.wyvernsting, 		false, 	true, 	JSHB.pos.BELOW },
		{ JSHB.spellid.freezingtrap,		false, 	true, 	JSHB.pos.BELOW },
		{ JSHB.spellid.bloodfury,		true, 	true, 	JSHB.pos.ABOVE },
		{ JSHB.spellid.bloodfury,		false, 	true, 	JSHB.pos.BELOW },
	},
}

JSHB.updateSettings = nil
